{ ணࠬ ᮢ ⢠ 
 : mandel
	     ⢮
	 mandel file.pcx
	    ⢮  file.pcx
   㢥祭 ࠧ
 ⪮   ⨭,  ⠪ 롮
   6 
  䠩 pcx 뢠 ⠪ 㦥 ଠ,
  :  ⢠  ࠧ襭

 ࠡ⠭ ⠭⨭ 㡭  1994 .
 E-mail: const@const.krasnoyarsk.su }

program Mandelbrott;

uses Crt, Dos, Global, WorkPcx;

type
  PBuffer = ^byte;
  Complex = record
    Re, Im: double
  end;
  Config = record
    Name: string[12];
  end;
  Square = object
    X, Y: word;
    Size: word;
    BufSize: word;
    PBuffer: ^byte;
    procedure Init( NewX, NewY, NewSize: word );
    procedure Show;
    procedure Hide;
    procedure ChangeSize( NewSize: integer );
    procedure MoveTo( NewX, NewY: integer );
    function GetX: word;
    function GetY: word;
    function GetSize: word;
   end;

const
  MaxIter = 1000;				{ ᨬ쭮 ᫮ 権 }
  MaxColor = 250;				{ ᫮ 梥⮢ }

const						{  }
  Palette1: array[1..37] of shortint = ( 21,-3,0,0,31,2,-2,0,31,0,2,-2,31,-2,
	0,2,21,0,-3,0,31,2,0,-2,31,-2,2,0,31,0,-2,2,21,0,0,-3,0 );
  Palette2: array[1..37] of shortint = ( 21,-3,0,0,31,1,-2,-1,31,1,1,-1,31,-2,
	1,2,21,0,-3,0,31,2,1,-1,31,-1,1,-1,31,-1,-2,2,21,0,0,-3,0 );
  Palette3: array[1..37] of shortint = ( 21,-3,0,0,31,1,-2,-1,31,1,1,-1,31,-2,
	1,2,21,0,-3,0,31,1,2,-2,31,1,-1,1,31,-2,-1,1,21,0,0,-3,0 );
  Palette4: array[1..37] of shortint = ( 21,0,0,-3,31,-2,0,2,31,2,-2,0,31,0,
	2,-2,21,-3,0,0,31,0,-2,2,31,2,0,-2,31,-2,2,0,21,0,-3,0,0 );
  Palette5: array[1..45] of shortint = ( 15,-4,0,0,1,-3,0,0,31,1,-2,0,31,1,1,-2,
	31,-2,1,1,31,1,-2,1,31,1,1,-2,31,-2,1,1,31,0,-2,1,1,0,0,-3,15,0,0,-4,0 );
  Palette6: array[1..69] of shortint = ( 9,-7,0,0,21,3,0,-3,9,0,-7,0,21,-3,0,3,
	9,7,0,0,21,0,3,-3,9,-7,0,0,21,3,0,3,9,0,-7,0,21,-3,3,0,9,0,0,-7,
	21,3,-3,0,21,0,3,3,9,0,0,-7,21,-3,0,3,9,0,0,-7,9,0,-7,0,0 );


procedure Square.Init;
begin
  X := NewX;
  Y := NewY;
  Size := NewSize
end;

procedure Square.Show;
var
  Cnt: word;
begin
  GetMem( PBuffer,  Size * 2 * 4 );	{    }
  for Cnt := X - Size to X + Size do begin
    PBuffer^ := GetPixel( Cnt, Y - Size );
    SetPixel( Cnt, Y - Size, Black );
    Inc( PBuffer );
    PBuffer^ := GetPixel( Cnt, Y + Size );
    SetPixel( Cnt, Y + Size, Black );
    Inc( PBuffer )
  end;
  for Cnt := Y - Size + 1 to Y + Size - 1 do begin
    PBuffer^ := GetPixel( X - Size, Cnt );
    SetPixel( X - Size, Cnt, Black );
    Inc( PBuffer );
    PBuffer^ := GetPixel( X + Size, Cnt );
    SetPixel( X + Size, Cnt, Black );
    Inc( PBuffer )
  end
end;

procedure Square.Hide;
var
  Cnt: word;
begin
  for Cnt := Y + Size - 1 downto Y - Size + 1 do begin
    Dec( PBuffer );
    SetPixel( X + Size, Cnt, PBuffer^ );
    Dec( PBuffer );
    SetPixel( X - Size, Cnt, PBuffer^ )
  end;
  for Cnt := X + Size downto X - Size do begin
    Dec( PBuffer );
    SetPixel( Cnt, Y + Size, PBuffer^ );
    Dec( PBuffer );
    SetPixel( Cnt, Y - Size, PBuffer^ )
  end;
  FreeMem( PBuffer, Size * 2 * 4 )
end;

procedure Square.ChangeSize;
begin
  Hide;
  Inc( Size, NewSize );
  Show
end;

procedure Square.MoveTo;
begin
  Hide;
  Inc( X, NewX );
  Inc( Y, NewY );
  Show
end;

function Square.GetX;
begin
  GetX := X
end;

function Square.GetY;
begin
  GetY := Y
end;

function Square.GetSize;
begin
  GetSize := Size
end;


var
  Pict: file of byte;
  FileName: string[31];
  FindFile: SearchRec;
  Constant: Complex;
  Step: Complex;
  Center: Complex;
  Scale: double;
  Four, Two: double;
  TempX, TempY: double;
  VarConf: Config;
  Cnt, Cnt1, Cnt2: word;
  Error: integer;
  Rect: Square;
  BufPal: PBuffer;
  Temp: byte;
  Color: byte;
  Flag: boolean;

procedure DrawPicture;
begin
  Step.Re := 5.4 / ( MaxX * Scale );
  Step.Im := 4.0 / ( MaxY * Scale );
  Constant.Re := Center.Re - 2.7 / Scale;
  for Cnt1 := 0 to MaxX - 1 do begin
    Constant.Im := Center.Im - 2.0 / Scale;
    for Cnt2 := MaxY - 1 downto 0 do begin	{  ᪮७ ⮢}
	asm					{  ᫥  ᥬ }
	  mov	Cnt,1
	  fld	Constant.Im
	  fld	Constant.Re
	  fldz
	  fldz
	  fldz
	  fldz
      @1: fld	Two		{ 2.0 }
	  fmul	st,st(2)	{ * Number.Re }
	  fmul	st,st(1)	{ * Number.Im }
	  fadd	st,st(6)	{ + Constant.Im }
	  fstp	st(1)		{ -> Number.Im }
	  fld	st(3)		{ Square.Re }
	  fsub	st,st(3)	{ - Square.Im }
	  fadd	st,st(5)	{ + Constant.Re }
	  fst	st(2)		{ -> Number.Re }
	  fmul	st,st(2)	{ * Number.Re }
	  fst	st(4)		{ -> Square.Re }
	  fld	st(1)		{ Number.Im }
	  fmul	st,st(2)	{ * Number.Im }
	  fst	st(4)		{ -> Square.Im }
	  faddp st(1),st	{ Square.Im + Square.Re }
	  fcomp Four            { compare with 4.0 }
	  fstsw ax
	  sahf
	  jnb @2
	  inc   Cnt
	  cmp	Cnt,MaxIter-2
	  jbe @1
      @2: fstp	st
	  fstp	st
	  fstp	st
	  fstp	st
	  fstp	st
	  fstp	st
	end;
      SetPixel( Cnt1, Cnt2, Cnt div ( MaxIter div MaxColor ));
      Constant.Im := Constant.Im + Step.Im
    end;
    Constant.Re := Constant.Re + Step.Re
  end;
end;

{var
  Driver: integer;
  Mode: integer;}

{$DEFINE VESA}
begin
  Two := 2.0;
  Four := 4.0;
  FileName := ParamStr( 1 );			{  ⠥ 䠩 }
  Center.Re := 0.0;
  Center.Im := 0.0;
  Scale := 1.0;
  asm
{$IFDEF VGA}
    mov ax,13h				{ for VGA adapter: 320x200x256 }
{$ENDIF}
{$IFDEF CIRRUS}
    mov ax,5Fh				{ for Cirrus Logic adapter: 640x480x256 }
{$ENDIF}
{$IFDEF VESA}
    mov ax,4F02h			{ for VESA-compatible adapter: 640x480x256 }
    mov	bx,101h
{$ENDIF}
    int 10h
  end;
  SetPalette( @Palette1 );		{  㬮砭 1-  }
  if FileName <> '' then
    Flag := ReadFile( FileName, @Center.Re, @Center.Im, @Scale )
  else Flag := False;
  if not Flag then DrawPicture;
  Rect.Init( MaxX div 2, MaxY div 2, MaxY div 20 );
  Rect.Show;
  repeat
    case ReadKey of
      #0: case ReadKey of		{ ५窨  PgUp  PgDown }
	#72: Rect.MoveTo( 0, -1 );	{  }
	#75: Rect.MoveTo( -1, 0 );	{  }
	#77: Rect.MoveTo( 1, 0 );	{ ࠢ }
	#80: Rect.MoveTo( 0, 1 );	{  }
	#73: Rect.ChangeSize( 1 );	{ 㢥 ࠧ 誠 }
	#81: Rect.ChangeSize( -1 )	{ 㬥 ࠧ 誠 }
      end;
      '1': SetPalette( @Palette1 );	{   1  6   }
      '2': SetPalette( @Palette2 );
      '3': SetPalette( @Palette3 );
      '4': SetPalette( @Palette4 );
      '5': SetPalette( @Palette5 );
      '6': SetPalette( @Palette6 );
      'W','w': begin			{   䠩 }
	Rect.Hide;
	WriteFile( @Center.Re, @Center.Im, @Scale );
	Rect.Show
      end;
      'R', 'r': begin			{   䠩 }
	Rect.Hide;
	ReadFile( FileName, @Center.Re, @Center.Im, @Scale );
	Rect.Show
      end;
      #13: begin			{ Enter - ᮢ ᮣ᭮ 誠 }
	Rect.Hide;
	TempX := MaxX div 2;
	TempY := MaxY div 2;
	Center.Re := Center.Re + ( Rect.GetX - TempX ) * 2.7 / TempX / Scale;
	Center.Im := Center.Im + ( TempY - Rect.GetY ) * 2.0 / TempY / Scale;
	Scale := Scale * TempY / Rect.GetSize;
	DrawPicture;
	Rect.Init( MaxX div 2, MaxY div 2, MaxY div 20 );
	Rect.Show
      end;
      #27: Break			{ ESC - 室 }
    end
  until False;
  Rect.Hide;
  asm
    mov ax,3				{ ⠭ ⥪⮢ ० 8025 }
    int 10h
  end
end.